PImage img;

// The number of columns and rows must be the same.
int cols = 512, rows = 512;

int[][] baseArray;

void setup() {
  size(512, 512);
  background(0);
  
  /*
  img = loadImage("sunflower.jpg");
  smooth();
  */
  
  // Declare 2D array
  baseArray = new int[cols][rows];
  
  // Initialize 2D array values
  for (int i = 0; i < cols; i++) {
    for (int j = 0; j < rows; j++) {
      baseArray[i][j] = int(random(255));
    }
  }
  
  for (int i = 1; i < 6; ++i) baseArray = midpointDisplacnewArrayt(baseArray, 64 / i);
  
  // Draw points
  for (int i = 0; i < cols; i++) {
    for (int j = 0; j < rows; j++) {
      stroke(baseArray[i][j]);
      point(i, j);
    }
  }
  
}

int[][] midpointDisplacnewArrayt(int[][] base, int roughness) {
  int baseSize = base[0].length;
  int newSize = (2 * baseSize) - 1;
  
  int[][] newArray = new int[newSize][newSize];
  
  // Resize
  for (int i = 0; i < newSize; i += 2) {
    for (int j = (!(i % 2 == 0)) ? 1 : 0; j < newSize; j += 2) {
      newArray[i][j] = base[i / 2][j / 2];
    }
  }
  
  // Diamond algorithm
  for (int i = 1; i < newSize; i += 2) {
    for (int j = 1; j < newSize; j += 2) {

      int a = newArray[i - 1][j - 1];
      int b = newArray[i - 1][j + 1];
      int c = newArray[i + 1][j - 1];
      int d = newArray[i + 1][j + 1];
      newArray[i][j] = (a + b + c + d) / 4;

      int r = int(random(-roughness, roughness));
      if (newArray[i][j] + r > 255 )
        newArray[i][j] = 255;
      else if(newArray[i][j] + r < 0)
        newArray[i][j] = 0;
      else
        newArray[i][j] += r;
    }
  }
  
  // Square algorithm
  for (int i = 0; i < newSize; ++i) {
    for (int j = (i % 2 == 0) ? 1: 0; j < newSize; j += 2) {
      // get surrounding values
      int a = 0, b = a, c = a, d = a;
      if (i != 0) a = newArray[i - 1][j];
      if (j != 0) b = newArray[i][j - 1];
      if (j + 1 != newSize) c = newArray[i][j + 1];
      if (i + 1 != newSize) d = newArray[i + 1][j];

      // average calculation
      if (i == 0) newArray[i][j] = (b + c + d) / 3;
      else if (j == 0) newArray[i][j] = (a + c + d) / 3;
      else if (j + 1 == newSize) newArray[i][j] = (a + b + d) / 3;
      else if (i + 1 == newSize) newArray[i][j] = (a + b + c) / 3;
      else newArray[i][j] = (a + b + c + d) / 4;

      int r = int(random(-roughness, roughness));
      if (newArray[i][j] + r > 255 )
        newArray[i][j] = 255;
      else if(newArray[i][j] + r < 0)
        newArray[i][j] = 0;
      else
        newArray[i][j] += r;
    }
  }
  
  return newArray;  // Returns an array of 3 ints: 20, 40, 60 
}

/*
void draw() {
  // Draw points
  for (int i = 0; i < cols; i++) {
    for (int j = 0; j < rows; j++) {
      stroke(baseArray[i][j]);
      point(i, j);
    }
  }
}
*/

  /*
  // Pick a random point
  int x = int(random(img.width));
  int y = int(random(img.height));
  int loc = x + y*img.width;
  
  // Look up the RGB color in the source image
  loadPixels();
  float r = red(img.pixels[loc]);
  float g = green(img.pixels[loc]);
  float b = blue(img.pixels[loc]);
  noStroke();
  
  // Draw an ellipse at that location with that color
  fill(r,g,b,100);
  ellipse(x,y,pointillize,pointillize);
  */